///////////////////////////////////////////////////////////////////////////////
// NABLA - a Numerical Analysis Based LAnguage                               //
//                                                                           //
// Copyright (C) 2014~2017 CEA/DAM/DIF                                       //
// IDDN.FR.001.520002.000.S.P.2014.000.10500                                 //
//                                                                           //
// Contributor(s): TRAN Guillaume - Guillaume.Tran@polytechnique.edu         //
//                 LOISEAU Pascal - Pascal.Loiseau@cea.fr                    //
//                 CAMIER Jean-Sylvain - Jean-Sylvain.Camier@cea.fr          //
//                                                                           //
// This software is a computer program whose purpose is to translate         //
// numerical-analysis specific sources and to generate optimized code        //
// for different targets and architectures.                                  //
//                                                                           //
// This software is governed by the CeCILL license under French law and      //
// abiding by the rules of distribution of free software. You can  use,      //
// modify and/or redistribute the software under the terms of the CeCILL     //
// license as circulated by CEA, CNRS and INRIA at the following URL:        //
// "http://www.cecill.info".                                                 //
//                                                                           //
// The CeCILL is a free software license, explicitly compatible with         //
// the GNU GPL.                                                              //
//                                                                           //
// As a counterpart to the access to the source code and rights to copy,     //
// modify and redistribute granted by the license, users are provided only   //
// with a limited warranty and the software's author, the holder of the      //
// economic rights, and the successive licensors have only limited liability.//
//                                                                           //
// In this respect, the user's attention is drawn to the risks associated    //
// with loading, using, modifying and/or developing or reproducing the       //
// software by the user in light of its specific status of free software,    //
// that may mean that it is complicated to manipulate, and that also         //
// therefore means that it is reserved for developers and experienced        //
// professionals having in-depth computer knowledge. Users are therefore     //
// encouraged to load and test the software's suitability as regards their   //
// requirements in conditions enabling the security of their systems and/or  //
// data to be ensured and, more generally, to use and operate it in the      //
// same conditions as regards security.                                      //
//                                                                           //
// The fact that you are presently reading this means that you have had      //
// knowledge of the CeCILL license and that you accept its terms.            //
//                                                                           //
// See the LICENSE file for details.                                         //
///////////////////////////////////////////////////////////////////////////////

ℝ sigmoide(const ℝ I, const ℝ temps_montee, const ℝ temps){
  const ℝ ε1 = ε;
  const ℝ ε2 = ε;
  const ℝ a =1.0/temps_montee*log(ε1*ε2/(1.0-ε1)/(1.0-ε2));
  const ℝ b =log((1.0-ε1)/ε1);
  return I/(1.0+exp(a*temps+b)) ;
}

ℝ Heaviside(const ℝ x){
  if(x >= 0.0) return 1.0;
  return 0.0;
}

ℝ Heaviside_strict(const ℝ x){
  if(x > 0.0) return 1.0;
  return 0.0;
}

ℝ Heaviside_lisse(const ℝ x, const ℝ largeur){
  if(largeur == 0) return 1.0;
  return 1.0/(1.0+exp(2.0*x/largeur));
}
